<script setup>
  import useVuelidate from "@vuelidate/core";
import {
  required,
  email,
 } from "@vuelidate/validators";
import { reactive, ref, computed } from "vue";
import { useRouter } from "vue-router";
import { mdiAccount, mdiAsterisk } from "@mdi/js";
import FullScreenSection from "@/components/FullScreenSection.vue";
import SectionComponent from "@/components/SectionComponent.vue";
import CheckRadioPicker from "@/components/CheckRadioPicker.vue";
import Field from "@/components/Field.vue";
import Control from "@/components/Control.vue";
import ModalBox from "@/components/ModalBox.vue";
import Divider from "@/components/Divider.vue";
import JbButton from "@/components/JbButton.vue";
import JbButtons from "@/components/JbButtons.vue";
import AuthService from "@/api/authService";
import { useToast } from "vue-toastification";
const toast = useToast();
const router = useRouter();
const isModalDangerActive = ref(false);
const user = reactive({
  email: "",
});
// Validation
const rules = computed(() => {
  return {
    email: { required, email },
  };
});
const v$ = useVuelidate(rules, user);
const forgetPassword = async () => {
  // vuelidate validation
  v$.value.$validate();
    // if success
    if (!v$.value.$error) {
  AuthService.forgetPass(user)
    .then((data) => {
      console.log("data", data?.success);
      if (data?.success) {
        toast.success(data?.message);
        router.push("/reset-password");
      } else {
        toast.error(data?.message);
      }
    })
    .catch((error) => {
      let message =
        error?.data?.message ||
        "No such registered user found. Please get yourself registered first.";
      toast.error(message);
    });
  }
};
</script>

<template>
  <Transition :duration="{ enter: 500, leave: 800 }" name="nested">
    <modal-box
      v-model="isModalDangerActive"
      large-title="Please confirm"
      button="danger"
      has-cancel
      class="py-6"
    >
      <div class="py-8">
        <img />
        <p class="text-gray-250 font-semibold">
          We have send you a link to Reset Your Password
        </p>
      </div>
      <jb-button
        color=""
        label="ok"
        class="mt-2 bg-pink-250 text-white px-6 font-seemibold py-2 rounded-lg"
        to="/otp"
      />
    </modal-box>
  </Transition>
  <full-screen-section
    v-slot="{ cardClass, cardRounded }"
    bg="login"
    class="h-full py-6 px-4"
  >
    <div class="row w-full justify-between my-1 mb-4 px-32 py-10 h-full">
      <router-link to="/">
        <img src="@/assets/icons/logo.svg" />
      </router-link>
    </div>
    <div class="flex justify-center justify-items-center">
      <div
        class="bg-white md:inline-flex md:px-14 px-4 py-20 w-4/5 rounded-lg shadow-pink-150 dropShadow-outer-lg"
      >
        <span class="md:w-1/2 w-full md:px-10 px-2">
          <h5 class="text-center text-pink-250 font-normal text-3xl mb-4">
            "Labour Care Guide"
          </h5>
          <center class="py-10">
            <img
              src="@/assets/icons/login-icon.svg"
              style="width: 300px"
              alt="logo"
            />
          </center>
        </span>
        <section-component
          class="md:w-1/2 w-full md:px-10 px-0 shadow-none"
          :class="cardClass"
          :rounded="cardRounded"
        >
          <h5 class="text-left text-pink-250 font-semibold text-2xl mb-2">
            Forget Password
          </h5>
          <p class="py-4 mb-6">
            Please enter your registered email id to receive password reset link
          </p>
          <field label="Email ID">
            <div class="flex-wrap">
            <control
              v-model="user.email"
              placeholder="Enter Email Id"
              name="email"
              autocomplete="email"
              class="w-full" @input="v$.email.$touch()"
            />
            <Transition>
              <p class="text-pink-250 pl-2 texts-m" v-if="v$.email.$error">
                {{ v$.email.$errors[0].$message }}
              </p></Transition
            ></div>
          </field>

          <jb-buttons>
            <jb-button
              color=""
              label="Submit"
              class="mt-2 bg-pink-250 text-white w-full font-seemibold py-3 rounded-lg"
              @click="forgetPassword"
            />
          </jb-buttons>
        </section-component>
      </div>
    </div>
  </full-screen-section>
</template>
